var ResourceDisplays = {};

ResourceDisplays.autoInit = () => {
  for (let propertyName in ResourceDisplays) {
    let property = ResourceDisplays[propertyName];
    // Call autoInit of all properties that are subclasses of `ResourceDisplays.ResourceDisplay`.
    // This does not include `ResourceDisplays.ResourceDisplay` itself.
    if (property.prototype instanceof ResourceDisplays.ResourceDisplay) {
      // Check if the static `htmlClass` property is defined.
      if (property.htmlClass === undefined) {return;}
      // Gather all HTML elements that have the `this.htmlClass` class
      // and do not have the `no-autoinit` class.
      let displayElements = document.querySelectorAll(`.${property.htmlClass}:not(.no-autoinit)`);
      // Create an instance of this class for each display element.
      for (let displayElement of displayElements) {new property(displayElement);}
    }
  }
};
